<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" />
  <style>
    .completed {
      text-decoration: line-through;
    }
  </style>
  <title>Delete Todo</title>
</head>

<body style="background-color:#fdfefe ">
  <div id="app">
    <div class="container mt-5 justify-content-end">
      <div class="row d-flex justify-content-center">
        <div class="col-md-8">
          <div class="mb-3">
            <input type="text" class="form-control" v-model="todo" @keyup.enter="addTodo" placeholder="Todo" />
          </div>
          <ul class="list-group border-0 shadow">
            <li v-for="(todo, index) in todos" :key="index" class="list-group-item d-flex justify-content-between" @click="statusTodo(todo)">
              <span :class="{completed: todo.completed}">{{ todo.title }}</span>
              <span @click="deleteTodo(todo)" class="btn btn-sm btn-danger">DELETE</span>
            </li>
          </ul>
          <div class="status mt-3">
            <h5>Done: <strong>{{ done }}</strong></h5>
            <h5>Pending: <strong>{{ pending }}</strong></h5>
          </div>
        </div>
      </div>
    </div>
  </div>
  <script src="https://unpkg.com/vue@3/dist/vue.global.js"></script>
  <script src="https://unpkg.com/vuex@4"></script>
  <script>
    // create store vuex
    const store = Vuex.createStore({
      // state
      state: {
        todos: [
          {
            title: "Learn",
            completed: false,
          },
          {
            title: "Meet up client",
            completed: true,
          },
          {
            title: "Go Home",
            completed: false,
          },
        ],
      },

      // mutations
      mutations: {
        // add todos
        ADD_TODO(state, data) {
          // push payload to todo
          state.todos.push({
            title: data,
            completed: false,
          });
        },

        // status todo
        STATUS_TODO(state, data) {
          data.completed = !data.completed;
        },

        // delete todo
        DELETE_TODO(state, data) {
          let index = state.todos.indexOf(data);
          state.todos.splice(index, 1);
        },
      },

      // actions
      actions: {
        // action add todo
        addTodo({ commit }, data) {
          // commit to mutations "ADD_TODO"
          commit("ADD_TODO", data);
        },

        // action change status todo
        statusTodo({ commit }, data) {
          //commit to mutations "STATUS_TODO"
          commit("STATUS_TODO", data);
        },

        //action delete todo
        deleteTodo({ commit }, data) {
          //commit to mutations "DELETE_TODO"
          commit("DELETE_TODO", data);
        },
      },

      // getters
      getters: {
        // getter length todos status completed(true)
        doneTodos(state) {
          return state.todos.filter(function (item) {
            return item.completed == true;
          }).length;
        },

        // getter length todos status pending(false)
        pendingTodos(state) {
          return state.todos.filter(function (item) {
            return item.completed == false;
          }).length;
        },
      },
    });

    // vue create app
    const app = Vue.createApp({
      data() {
        return {
          todo: "",
        };
      },

      computed: {
        todos() {
          // get todos from state
          return this.$store.state.todos;
        },
        done() {
          //get todos completed from getters vuex
          return this.$store.getters.doneTodos;
        },

        pending() {
          //get todos pending from getters vuex
          return this.$store.getters.pendingTodos;
        },
      },

      methods: {
        addTodo() {
          // call action "addTodo" on vuex
          this.$store.dispatch("addTodo", this.todo);

          // empty todo state
          this.todo = "";
        },

        statusTodo(todo) {
          // call action "statusTodo" on vuex
          this.$store.dispatch("statusTodo", todo);
        },

        deleteTodo(todo) {
          // call action "deleteTodo" on vuex
          this.$store.dispatch('deleteTodo', todo);
        }
      },
    });

    // use vuex
    app.use(store);
    // mounth to attribute ID app
    app.mount("#app");
  </script>
</body>

</html>